/******************************************************************************/
/****         Generated by IBExpert 2011.09.05 01-10-2011 20:02:59         ****/
/******************************************************************************/

SET SQL DIALECT 3;

SET NAMES NONE;

SET CLIENTLIB 'fbclient.dll';

CREATE DATABASE 'repositorio.fdb'
USER 'SYSDBA' PASSWORD 'masterkey'
PAGE_SIZE 8192
DEFAULT CHARACTER SET NONE;



/******************************************************************************/
/****                              Generators                              ****/
/******************************************************************************/

CREATE GENERATOR GEN_ARQUIVO;
SET GENERATOR GEN_ARQUIVO TO 0;

CREATE GENERATOR GEN_PESSOA;
SET GENERATOR GEN_PESSOA TO 0;



/******************************************************************************/
/****                                Tables                                ****/
/******************************************************************************/



CREATE TABLE ARQUIVO (
    ID_ARQUIVO     INTEGER NOT NULL,
    ID_PESSOA      INTEGER NOT NULL,
    NOME_ARQUIVO   VARCHAR(20) NOT NULL,
    NOME_ORIGINAL  VARCHAR(200) NOT NULL,
    DATA_CRIACAO   DATE,
    OBSERVACAO     VARCHAR(100)
);


CREATE TABLE PESSOA (
    ID_PESSOA  INTEGER NOT NULL,
    NOME       VARCHAR(30),
    TELEFONE   VARCHAR(10)
);




/******************************************************************************/
/****                             Primary Keys                             ****/
/******************************************************************************/

ALTER TABLE ARQUIVO 
ADD CONSTRAINT PK2 PRIMARY KEY (ID_ARQUIVO, ID_PESSOA);

ALTER TABLE PESSOA 
ADD CONSTRAINT PK1 PRIMARY KEY (ID_PESSOA);


/******************************************************************************/
/****                             Foreign Keys                             ****/
/******************************************************************************/

ALTER TABLE ARQUIVO 
ADD CONSTRAINT REFPESSOA1 FOREIGN KEY (ID_PESSOA) 
REFERENCES PESSOA (ID_PESSOA);


/******************************************************************************/
/****                               Triggers                               ****/
/******************************************************************************/


SET TERM ^ ;



/******************************************************************************/
/****                         Triggers for tables                          ****/
/******************************************************************************/



/* Trigger: ARQUIVO_BI */
CREATE TRIGGER ARQUIVO_BI FOR ARQUIVO
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID_ARQUIVO IS NULL) THEN
    NEW.ID_ARQUIVO = GEN_ID(GEN_ARQUIVO,1);
END
^


/* Trigger: PESSOA_BI */
CREATE TRIGGER PESSOA_BI FOR PESSOA
ACTIVE BEFORE INSERT POSITION 0
AS
BEGIN
  IF (NEW.ID_PESSOA IS NULL) THEN
    NEW.ID_PESSOA = GEN_ID(GEN_PESSOA,1);
END
^


SET TERM ; ^

